/*____________________________________________________________________________*\
 *

 Copyright (c) 1997 John Roy. All rights reserved.

 These sources, libraries and applications are
 FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 as long as the following conditions are adhered to.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer. 

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.

 3. Redistributions of any form whatsoever and all advertising materials 
    mentioning features must contain the following
    acknowledgment:
    "This product includes software developed by John Roy
    (http://www.johnroy.com/pi3/)."

 THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE AUTHORS OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 OF THE POSSIBILITY OF SUCH DAMAGE.

 *____________________________________________________________________________*|
 *
 * $Source: _PIDBKey.h$
 * $Date: Sun Aug 10 06:29:58 1997$
 *
 Description:
	Internal keys into the program database including configuration file
	variable names.
\*____________________________________________________________________________*/
/* $HeaderTop:$ */

#ifndef _PIDBKEYS_H_
#define _PIDBKEYS_H_

#include "PIDBKeys.h"

/* --- name of standard database object (tree and nodes) --- */
#define PIDBKEY_MIMETYPES		"MIMETypes"		/* mime types */
#define PIDBKEY_PROGRAM			"Program"		/* top of program tree */
#define PIDBKEY_SLL				"SLL"			/* SLL tree */

/* --- keys used in configuration file --- */
#define PIDBKEY_CONF_MIME		"MIME"
#define PIDBKEY_CONF_ENTRYFUNCTION	"EntryFunction"
#define PIDBKEY_CONF_PWD		"PresentWorkingDirectory"

/* --- the keys to top level program values --- */
#define PIDBKEY_PROGRAM			"Program"
#define PIDBKEY_VERSION			"Version"
#define PIDBKEY_VERSION_MAJOR	"Version Major"
#define PIDBKEY_VERSION_MINOR	"Version Minor"
#define PIDBKEY_VERSION_PATCH	"Version Patch"

/* --- keys to function names for loadable classes --- */
#define PIDBKEY_FN_ONCLASSLOAD	"OnClassLoad"
#define PIDBKEY_FN_CONSTRUCTOR	"Constructor"
#define PIDBKEY_FN_COPYCONSTRUCTOR	"CopyConstructor"
#define PIDBKEY_FN_DESTRUCTOR	"Destructor"
#define PIDBKEY_FN_OUT			"Out"
#define PIDBKEY_FN_IN			"In"
#define PIDBKEY_FN_EXECUTE		"Execute"

/* --- the keys to program arguments --- */
#define PIDBKEY_CONFIGFILE		"Configuration File"
#define PIDBKEY_SLLFILE			"SLLFile"
#define PIDBKEY_FUNCTION		"Function"

#endif	/* _PIDBKEYS_H_ */

