/*____________________________________________________________________________*\
 *

 Copyright (c) 1997 John Roy. All rights reserved.

 These sources, libraries and applications are
 FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 as long as the following conditions are adhered to.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
	notice, this list of conditions and the following disclaimer. 

 2. Redistributions in binary form must reproduce the above copyright
	notice, this list of conditions and the following disclaimer in
	the documentation and/or other materials provided with the
	distribution.

 3. Redistributions of any form whatsoever and all advertising materials 
	mentioning features must contain the following
	acknowledgment:
	"This product includes software developed by John Roy
	(http://www.johnroy.com/pi3/)."

 THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE AUTHORS OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 OF THE POSSIBILITY OF SUCH DAMAGE.

 *____________________________________________________________________________*|
 *
 * $Source: GeneralPage.cpp$
 * $Date: Sun Aug 10 06:36:50 1997$
 *
 Description:

\*____________________________________________________________________________*/
//$SourceTop:$

#include <iostream.h>
#include <stdio.h>

#include "IFaceBse.h"
#include "PIStrStr.h"
#include "StrToken.h"

#include "QConfig.h"
#include "General.hrc"

/*
** #define D { cerr << __FILE__ << ": " << __LINE__ << endl; }
*/
// #define D { cerr << __FILE__ << ": " << __LINE__ << endl; }
#define D

/*____________________________________________________________________________*\
 *
 Description:
\*____________________________________________________________________________*/
#define C_RESOURCENAME                    "GeneralPage"

/*____________________________________________________________________________*\
 *
 Description:
\*____________________________________________________________________________*/
#if 0
	/*
	** HTML documentation for this handler
	*/
/*___+++HTMLDOC_BEGIN+++___*/
Name:
    GeneralPage

Description:
    No description yet.

Example:
	<PRE>
	&ltObject&gt
		Name GeneralPage
		Class GeneralPageClass
        PropertyPage GeneralPage
	&lt/Object&gt

	</PRE>

/*___+++HTMLDOC_END+++___*/
#endif

/*____________________________________________________________________________*\
 *
 Description:
\*____________________________________________________________________________*/
static BOOL CALLBACK fnDialogProc(HWND hDlg, UINT uMsg, WPARAM wParam,
    LPARAM lParam);

/*____________________________________________________________________________*\
 *
 Class:
 Description:
\*____________________________________________________________________________*/
class GeneralPage : public IFaceBase
{
private:
    QConfig *__pConfig;
    PROPSHEETPAGE tPsp;
    Interface *pInterface;

    /*
    ** window private values
    */
    HWND hWndHost;
    HWND hWndIP;
    HWND hWndLocal;
    HWND hWndEdit;
    HWND hWndPort;
    HWND hWndURL;
    HWND hWndAdmin;
    PIString *pHost;
    PIString *pIP;
    PIString *pLocal;
    int __iCurrentRadioButton;

	int Parameter( const char *pVariable, const char *pValue,
		const char *pWhere )
		{
		assert( pVariable && pValue );

		PIOStrStream os;

		os << pWhere << "GeneralPage: ";

        if ( 0 )
            {
            }
		else
			{
			os << "Unknown directive '" << pVariable <<
				"'" << ends;
			CONFIG_ERR( Object(), os.str() );
			return 0;
			};

		return 1;
		};

public:
	GeneralPage( PIObject *pObject, int iArgc, const char *ppArgv[] )
	:	IFaceBase( pObject ),
        __pConfig( FindParentQConfig( PIObject_getDB( pObject ) ) ),
        pInterface( 0 ),
        hWndHost( 0 ),
        hWndIP( 0 ),
        hWndLocal( 0 ),
        hWndEdit( 0 ),
        hWndPort( 0 ),
        hWndURL( 0 ),
        hWndAdmin( 0 ),
        __iCurrentRadioButton( 0 )
		{
		ReadParameters( iArgc, ppArgv );
		};

	~GeneralPage()
		{
		};

    virtual int Handle( Interface &tWindow )
        {
        switch( tWindow.iMessage )
            {
            case INTRFACE_MSG_INIT:
                pInterface = &tWindow;
                break;

            case INTRFACE_MSG_WIN32CREATE:
                return Win32Create( tWindow );

            case INTRFACE_MSG_LOAD:
            case INTRFACE_MSG_DEFAULTS:
                return PIAPI_ABORT;

            default:
                assert( 0 );
                return PIAPI_ABORT;
            };

        return PIAPI_COMPLETED;
        };

    int Win32Create( Interface &tWindow )
		{
#if 0
        /*
        ** Setup the PROPSHEETPAGE
        */
        memset( &tPsp, 0, sizeof( PROPSHEETPAGE ) );
        tPsp.dwSize = sizeof( PROPSHEETPAGE );
        tPsp.dwFlags = PSP_DEFAULT;
        tPsp.hInstance = PIDLL_getSystemHandle( PIClass_getLibrary(
            PIObject_getClass( Object() ) ) );

        /* Status page */
        tPsp.pszTemplate = C_RESOURCENAME;
        tPsp.pfnDlgProc = (DLGPROC)fnDialogProc;
        tPsp.lParam = (LPARAM)this;

        /*
        ** Set the data in the tWindow structure
        */
        tWindow.eType = Interface::PROPPAGE;
        tWindow.pUserData = &tPsp;
        
        /*
        ** Done
        */
#endif
        return PIAPI_COMPLETED;
		};

	PIString *Internal_stringFromRadioButton( int iId )
	    {
		switch( iId )
			{
			case IDC_REMOTEHOST:	return pHost;
			case IDC_REMOTEIP:	return pIP;
			case IDC_LOCAL:	return pLocal;
			default:
				assert( 0 );
			};
	
		return 0;
	    };
	
	void Internal_radioButtonChange( int iNewId )
	    {
		enum { BUF_SIZE=1023 };
		char szBuf[BUF_SIZE+1];
	
		/* --- Get current value --- */
		*szBuf = '\0';
		SendMessage( hWndEdit, WM_GETTEXT, BUF_SIZE, (LPARAM)szBuf );
		*(Internal_stringFromRadioButton( __iCurrentRadioButton )) = szBuf;
	
		__iCurrentRadioButton = iNewId;
	
		SendMessage( hWndEdit, WM_SETTEXT, 0, (LPARAM)(const char *)
			*(Internal_stringFromRadioButton( __iCurrentRadioButton )) );
	    };
	
	void Internal_updateURL( HWND hDlg )
	    {
		enum { BUF_SIZE=1023 };
		char szBuf[BUF_SIZE+1];
	
		/* --- Get current value --- */
		assert( M_LookupValue( __pConfig, "Internal", "URLProtocol" ) );
		strcpy( szBuf, M_LookupValue( __pConfig, "Internal", "URLProtocol" ) );
		int iLen = strlen( szBuf );
		SendMessage( hWndEdit, WM_GETTEXT, BUF_SIZE-7, (LPARAM)&(szBuf[iLen]) );
		iLen = strlen( szBuf );
		szBuf[iLen++] = ':';
		SendMessage( hWndPort, WM_GETTEXT, BUF_SIZE-iLen, (LPARAM)&(szBuf[iLen]) );
		assert( M_LookupValue( __pConfig, "Internal", "DefaultPort" ) );
		if ( atoi( &(szBuf[iLen]) )==atoi(M_LookupValue( __pConfig, "Internal", 
				"DefaultPort" )) )
			{ szBuf[--iLen] = '\0'; };
	
		/* --- now update the URL --- */
		SendMessage( hWndURL, WM_SETTEXT, 0, (LPARAM)szBuf );
		
		/* --- mark property sheet as modified --- */
		PropSheet_Changed( GetParent( hDlg ), hDlg );
	    };
	
	BOOL DialogProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
	    {
	    enum { BUF_SIZE=1023 };
	    char szBuf[BUF_SIZE+1];

	    switch (uMsg)
	        {
            case WM_INITDIALOG:
                break;  

#if 0
            case WM_NOTIFY:
                switch( ((NMHDR *)lParam)->code )
                    {
                    case PSN_QUERYCANCEL:
                        ::DestroyWindow( ::GetParent( hDlg ) );
                        ::PostQuitMessage( 0 );
                        return (TRUE);
                    };
                break;
#endif

            default:
                return (FALSE);
            };

        return FALSE;
        };
};

/*____________________________________________________________________________*\
 *
 Function:
 Synopsis:
 Description:
\*____________________________________________________________________________*/
static BOOL CALLBACK fnDialogProc(HWND hDlg, UINT uMsg, WPARAM wParam,
    LPARAM lParam)
{
    if ( uMsg==WM_INITDIALOG )
        {
        ::SetWindowLong( hDlg, DWL_USER, ((LPPROPSHEETPAGE)lParam)->lParam );
        };

    GeneralPage *pPage = (GeneralPage *)::GetWindowLong( hDlg, DWL_USER );
    return pPage ? pPage->DialogProc( hDlg, uMsg, wParam, lParam ) : FALSE;
}

/*____________________________________________________________________________*\
 *
 Function:
 Synopsis:
 Description:
\*____________________________________________________________________________*/
PUBLIC_PIAPI int GeneralPage_constructor( PIObject *pObj,
	int iArgc, const char *ppArgv[] )
{
	return IFaceBase_constructor( pObj, PI_NEW( GeneralPage( pObj,
		iArgc, ppArgv ) ) );
}

#if 0
/*___+++CNF_BEGIN+++___*/
	<Class>
		Name GeneralPageClass
		Type LogicExtension
		Library IntrFace
		OnClassLoad IFaceBase_onClassLoad
		Constructor GeneralPage_constructor
		CopyConstructor IFaceBase_copyConstructor
		Destructor IFaceBase_destructor
		Execute IFaceBase_execute
	</Class>

	<Object>
		Name GeneralPage
		Class GeneralPageClass
	</Object>

/*___+++CNF_END+++___*/
#endif

