
/*
 * Step 4: Initialize the program database functionality and
 * write a simple hello world.
 */

#include <iostream.h>
#include <stdlib.h>
#include <assert.h>

#include "Pi2API.h"

/* ---
--- */
const char *ppFiles[] =
{
"./Step6a.cnf",	// OK
"./Step6b.cnf",	// non-existant
"./Step6c.cnf",	// syntax error 
"./Step6d.cnf",	// syntax error
"./Step6e.cnf",	// suntax error
0
};

int iRet;
void Step6( PIDB *pDB )
{
	cout << "Program running on " << PIPlatform_getDescription() << endl;
	cout << endl;

	for( int i=0; ppFiles[i]; i++)
		{
		const char *pFile = ppFiles[i];
		cout << "Attempting to load configuration file:- '" << pFile << "'" 
			<< endl;
		PIConfig *pConfigDB = 0;
		if ( PIConfig_loadConfigurationFile( pDB, pFile, &pConfigDB ) )
			{ cout << "Load failed!." << endl; }
		else
			{ cout << "Load succeeded" << endl; };
		cout << "Printing diagnostics from configuration load." << endl;
		PILog_writeDiagnostics( pDB, PILOG_ALL, 0 );
		};
		
	cout << "Done" << endl;
	iRet = 0;
}

/* ---
--- */
int main()
{
	if ( PIProgram_enter( "dummy", PIPROGRAM_VERSION_1_0, Step6 ) )
		{
		cerr << "Program_enter() failed." << endl;
		exit( 1 );
		};

	return iRet;
}

